import re
from datetime import datetime
from django.utils.deprecation import MiddlewareMixin

from ..utils.response_utils import get_response


class ResponseMiddleware(MiddlewareMixin):
    def process_request(self, request):
        request.start_time = datetime.now()

    def process_response(self, request, response):
        if re.search("docs", request.path):
            return response
        return get_response(request, response)

    def process_exception(self, request, exception):
        request.trace = exception.args